package syscon.arbutus.product.services.legal.contract.dto.condition;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.*;

import syscon.arbutus.product.services.clientcustomfield.contract.dto.ClientCustomFieldValueType;
import syscon.arbutus.product.services.core.contract.dto.ArbutusConstraint;
import syscon.arbutus.product.services.core.contract.dto.CommentType;

/**
 * ConditionType for Condition of Case Management Service
 *
 * @author yshang, lhan
 * @version 1.0
 * @since December 20, 2012
 */
@ArbutusConstraint(constraints = { "conditionStartDate <= conditionEndDate" })
public class ConditionType implements Serializable {

    private static final long serialVersionUID = -757901375114542783L;
    List<ClientCustomFieldValueType> clientCustomFieldValueTypeList = new ArrayList<ClientCustomFieldValueType>();
    /**
     * Unique system generated identifier for the Condition generated from the Templates defined earlier.
     */
    private Long conditionId;
    /**
     * Date when the Condition was created. It is generated by service when creating a condition.
     */
    private Date conditionCreateDate;
    /**
     * Date when the condition is effective from
     */
    private Date conditionStartDate;
    /**
     * Date when the condition period is over
     */
    private Date conditionEndDate;
    /**
     * Placeholder to add comments for that condition
     */
    @Valid
    private Set<CommentType> conditionComments;
    /**
     * Status of the condition as active or inactive based on the Boolean value selected
     */
    private Boolean isConditionStatus;
    /**
     * Is a logical grouping of Conditions by Sentences, Orders, Charges etc. from the Condition Template type
     */
    @NotNull
    private String conditionType;
    /**
     * A condition can also be classified under different categories like Financial, Programs etc. Comes from the Condition Template type
     */
    private String conditionCategory;
    /**
     * Is a logical sub grouping of the Condition category. E.g. Condition category for Financials, could be sub grouped as Restitution to victims, Electronic monitor payment etc.
     */
    private String conditionSubCategory;
    /**
     * A placeholder to select the period of the condition restriction like days, hours etc
     */
    private String conditionPeriodUnit;
    /**
     * A placeholder to select the Distance unit
     */
    private String conditionDistanceUnit;
    /**
     * A placeholder to select the Currency unit
     */
    private String conditionCurrencyUnit;
    /**
     * A placeholder to record the period value
     */
    private Long conditionPeriodValue;
    /**
     * A placeholder to select the Distance unit
     */
    private Long conditionDistanceValue;
    /**
     * A placeholder to record the currency value
     */
    private BigDecimal conditionCurrencyAmount;
    /**
     * This field will be used to store standard legal description for the conditions
     */
    private String conditionDetails;
    /**
     * A placeholder to capture the fact that a condition has been satisfied for say release purposes
     */
    private Boolean isConditionSatisfied;
    /**
     * A placeholder to capture the date an amendment was made to the conditions imposed by a court e.g. court reduces the period of community service. All details of the amendment will be available with the Order it arose from. The presence of the amended date indicates that the condition was amended.
     */
    private Date conditionAmendmentDate;
    /**
     * A placeholder to capture the status of the Amendment which could be- Accepted, Rejected, In Progress.
     */
    private String conditionAmendmentStatus;
    //Module relationships of case management
    private Long orderSentenceId;
    private Set<Long> chargeIds;
    private Set<Long> caseInfoIds;
    private Long casePlanId;
    private boolean isHistorical;
    @Size(max = 200, message = "max length 200")
    private String shortName;

    /**
     * Constructor
     */
    public ConditionType() {
        super();
    }

    /**
     * Constructor
     *
     * @param conditionId              Long, Unique system generated identifier for the Condition generated from the Templates defined earlier.
     * @param conditionCreateDate      Date, Ignored. Date when the Condition was created. It is generated by service when creating a condition.
     * @param conditionStartDate       Date, Optional. Date when the condition is effective from.
     * @param conditionEndDate         Date, Optional. Date when the condition period is over.
     * @param conditionComments        Set&lt;CommentType>, Optional. Comments for that condition.
     * @param isConditionStatus        Boolean, Optional. Status of the condition.
     * @param conditionType            String, Required. A logical grouping of Conditions by Sentences, Orders, Charges etc. from the Condition Template type.
     * @param conditionCategory        String, Optional. A condition can also be classified under different categories like Financial, Programs etc. Comes from the Condition Template type.
     * @param conditionSubCategory     String, Optional. A logical sub grouping of the Condition category. E.g. Condition category for Financials, could be sub grouped as Restitution to victims, Electronic monitor payment etc.
     * @param conditionPeriodUnit      String, Optional. The period of the condition restriction like days, hours etc.
     * @param conditionDistanceUnit    String, Optional. The Distance unit.
     * @param conditionCurrencyUnit    String, Optional. The Currency unit.
     * @param conditionPeriodValue     Long, Optional. The period value.
     * @param conditionDistanceValue   Long, Optional. The Distance unit.
     * @param conditionCurrencyAmount  BigDecimal, Optional. The currency value.
     * @param conditionDetails         String, Optional. The standard legal description for the conditions.
     * @param isConditionSatisfied     Boolean, Optional. The fact that a condition has been satisfied for say release purposes.
     * @param conditionAmendmentDate   Date, Optional. The date an amendment was made to the conditions imposed by a court e.g. court reduces the period of community service. All details of the amendment will be available with the Order it arose from. The presence of the amended date indicates that the condition was amended.
     * @param conditionAmendmentStatus String, Optional. The status of the Amendment which could be- Accepted, Rejected, In Progress.
     * @param orderSentenceId          Long, Optional. Id of OrderSentence.
     * @param chargeIds                Set&lt;Long>, Optional. A set of IDs of Charge.
     * @param caseInfoIds              Set&lt;Long>, Optional. A set of IDs of CaseInformation.
     */
    public ConditionType(Long conditionId, Date conditionCreateDate, Date conditionStartDate, Date conditionEndDate, Set<CommentType> conditionComments,
            Boolean isConditionStatus, @NotNull String conditionType, String conditionCategory, String conditionSubCategory, String conditionPeriodUnit,
            String conditionDistanceUnit, String conditionCurrencyUnit, Long conditionPeriodValue, Long conditionDistanceValue, BigDecimal conditionCurrencyAmount,
            String conditionDetails, Boolean isConditionSatisfied, Date conditionAmendmentDate, String conditionAmendmentStatus, Long orderSentenceId,
            Set<Long> chargeIds, Set<Long> caseInfoIds) {
        super();
        this.conditionId = conditionId;
        this.conditionCreateDate = conditionCreateDate;
        this.conditionStartDate = conditionStartDate;
        this.conditionEndDate = conditionEndDate;
        this.conditionComments = conditionComments;
        this.isConditionStatus = isConditionStatus;
        this.conditionType = conditionType;
        this.conditionCategory = conditionCategory;
        this.conditionSubCategory = conditionSubCategory;
        this.conditionPeriodUnit = conditionPeriodUnit;
        this.conditionDistanceUnit = conditionDistanceUnit;
        this.conditionCurrencyUnit = conditionCurrencyUnit;
        this.conditionPeriodValue = conditionPeriodValue;
        this.conditionDistanceValue = conditionDistanceValue;
        this.conditionCurrencyAmount = conditionCurrencyAmount;
        this.conditionDetails = conditionDetails;
        this.isConditionSatisfied = isConditionSatisfied;
        this.conditionAmendmentDate = conditionAmendmentDate;
        this.conditionAmendmentStatus = conditionAmendmentStatus;
        this.orderSentenceId = orderSentenceId;
        this.chargeIds = chargeIds;
        this.caseInfoIds = caseInfoIds;
    }

    /**
     * isWellFormed -- To check the required properties of the type are provided.
     * <p>Required arguments: conditionCreateDate, conditionStartDate, conditionStartDate, conditionType
     *
     * @return Boolean True: well formed; False: not well formed
     */
    @Deprecated
    public Boolean isWellFormed() {
        if (conditionCreateDate == null) {
			return false;
		}

        if (conditionStartDate == null) {
			return false;
		}

        if (isConditionStatus == null) {
			return false;
		}

        if (conditionType == null) {
			unwellFormed("conditionType " + conditionType);
		}

        // AmendmentStatus is required only if AmendmentDate is present
        if (conditionAmendmentDate != null) {
            if (conditionAmendmentStatus == null) {
				unwellFormed("conditionAmendmentStatus " + conditionAmendmentStatus);
			}
        }

        if (conditionComments != null && conditionComments.size() > 0) {
            for (CommentType comment : conditionComments) {
                if (!comment.isWellFormed()) {
					unwellFormed("conditionComments " + conditionComments);
				}
            }
        }

        return true;
    }

    /**
     * isValid -- To validate the value of the properties of the type. This
     * includes checking the length, and ensuring the format of the presented
     * values.
     *
     * @return Boolean True: valid; False: invalid
     */
    @Deprecated
    public Boolean isValid() {
        if (conditionStartDate != null && conditionEndDate != null && conditionEndDate.before(conditionStartDate)) {
			invalid("conditionStartDate is after conditionEndDate: " + conditionStartDate + ", " + conditionEndDate);
		}

        if (conditionType == null) {
			invalid("conditionType " + conditionType);
		}

        if (conditionComments != null && conditionComments.size() > 0) {
            for (CommentType comment : conditionComments) {
                if (!comment.isValid()) {
					invalid("conditionComments " + conditionComments);
				}
            }
        }

        return true;
    }

    /**
     * Get conditionId -- Unique system generated identifier for the Condition.
     *
     * @return the conditionId
     */
    public Long getConditionId() {
        return conditionId;
    }

    /**
     * Set condition Identification -- Unique system generated identifier for the Condition.
     *
     * @param conditionId the conditionId to set
     */
    public void setConditionId(Long conditionId) {
        this.conditionId = conditionId;
    }

    /**
     * Get condition create date -- The date when the Condition was created.
     *
     * @return the conditionCreateDate
     */
    public Date getConditionCreateDate() {
        return conditionCreateDate;
    }

    /**
     * Set condition create date -- The date when the Condition was created.
     *
     * @param conditionCreateDate the conditionCreateDate to set
     */
    public void setConditionCreateDate(Date conditionCreateDate) {
        this.conditionCreateDate = conditionCreateDate;
    }

    /**
     * Get condition start date -- The date when the condition is effective from
     *
     * @return the conditionStartDate
     */
    public Date getConditionStartDate() {
        return conditionStartDate;
    }

    /**
     * Set condition start date -- The date when the condition is effective from
     *
     * @param conditionStartDate the conditionStartDate to set
     */
    public void setConditionStartDate(Date conditionStartDate) {
        this.conditionStartDate = conditionStartDate;
    }

    /**
     * Get condition end date -- Date when the condition period is over.
     * Date must not be earlier than ConditionStart Date.
     *
     * @return the conditionEndDate
     */
    public Date getConditionEndDate() {
        return conditionEndDate;
    }

    /**
     * Get condition end date -- Date when the condition period is over.
     * Date must not be earlier than ConditionStart Date.
     *
     * @param conditionEndDate the conditionEndDate to set
     */
    public void setConditionEndDate(Date conditionEndDate) {
        this.conditionEndDate = conditionEndDate;
    }

    /**
     * Get condition comments -- add comments for the condition
     *
     * @return the conditionComments
     */
    public Set<CommentType> getConditionComments() {
        if (conditionComments == null) {
			conditionComments = new HashSet<CommentType>();
		}
        return conditionComments;
    }

    /**
     * Set condition comments -- add comments for the condition
     *
     * @param conditionComments the conditionComments to set
     */
    public void setConditionComments(Set<CommentType> conditionComments) {
        this.conditionComments = conditionComments;
    }

    /**
     * Get condition status.
     *
     * @return the isConditionStatus
     */
    public Boolean getIsConditionStatus() {
        return isConditionStatus;
    }

    /**
     * Set condition status.
     *
     * @param isConditionStatus the isConditionStatus to set
     */
    public void setIsConditionStatus(Boolean isConditionStatus) {
        this.isConditionStatus = isConditionStatus;
    }

    /**
     * Get condition type -- Is a logical grouping of Conditions by Sentences, Orders, Charges etc.
     * It is a reference code value of ConditionType set.
     *
     * @return the conditionType
     */
    public String getConditionType() {
        return conditionType;
    }

    /**
     * Set condition type -- Is a logical grouping of Conditions by Sentences, Orders, Charges etc.
     * It is a reference code value of ConditionType set.
     *
     * @param conditionType the conditionType to set
     */
    public void setConditionType(String conditionType) {
        this.conditionType = conditionType;
    }

    /**
     * Get condition category -- A condition can also be classified under different categories like Financial, Programs etc.
     * It is a reference code value of ConditionCategory set.
     *
     * @return the conditionCategory
     */
    public String getConditionCategory() {
        return conditionCategory;
    }

    /**
     * Set condition category -- A condition can also be classified under different categories like Financial, Programs etc.
     * It is a reference code value of ConditionCategory set.
     *
     * @param conditionCategory the conditionCategory to set
     */
    public void setConditionCategory(String conditionCategory) {
        this.conditionCategory = conditionCategory;
    }

    /**
     * Get condition sub category -- Is a logical sub grouping of the Condition category. E.g.
     * Condition category for Financials, could be sub grouped as Restitution to victims, Electronic monitor payment etc.
     * It is a reference code value of ConditionSubCategory set.
     *
     * @return the conditionSubCategory
     */
    public String getConditionSubCategory() {
        return conditionSubCategory;
    }

    /**
     * Set condition sub category -- Is a logical sub grouping of the Condition category. E.g.
     * Condition category for Financials, could be sub grouped as Restitution to victims, Electronic monitor payment etc.
     * It is a reference code value of ConditionSubCategory set.
     *
     * @param conditionSubCategory the conditionSubCategory to set
     */
    public void setConditionSubCategory(String conditionSubCategory) {
        this.conditionSubCategory = conditionSubCategory;
    }

    /**
     * Get condition period unit -- A placeholder to select the period of the condition restriction like days, hours etc.
     * It is a reference code value of ConditionPeriodUnit set.
     *
     * @return the conditionPeriodUnit
     */
    public String getConditionPeriodUnit() {
        return conditionPeriodUnit;
    }

    /**
     * Set condition period unit -- A placeholder to select the period of the condition restriction like days, hours etc.
     * It is a reference code value of ConditionPeriodUnit set.
     *
     * @param conditionPeriodUnit the conditionPeriodUnit to set
     */
    public void setConditionPeriodUnit(String conditionPeriodUnit) {
        this.conditionPeriodUnit = conditionPeriodUnit;
    }

    /**
     * Get condition distance unit -- A placeholder to select the Distance unit.
     * It is a reference code value of ConditionDistanceUnit set.
     *
     * @return the conditionDistanceUnit
     */
    public String getConditionDistanceUnit() {
        return conditionDistanceUnit;
    }

    /**
     * Set condition distance unit -- A placeholder to select the Distance unit.
     * It is a reference code value of ConditionDistanceUnit set.
     *
     * @param conditionDistanceUnit the conditionDistanceUnit to set
     */
    public void setConditionDistanceUnit(String conditionDistanceUnit) {
        this.conditionDistanceUnit = conditionDistanceUnit;
    }

    /**
     * Get condition currency unit -- A placeholder to select the Currency unit.
     * It is a reference code value of ConditionCurrencyUnit set.
     *
     * @return the conditionCurrencyUnit
     */
    public String getConditionCurrencyUnit() {
        return conditionCurrencyUnit;
    }

    /**
     * Set condition currency unit -- A placeholder to select the Currency unit.
     * It is a reference code value of ConditionCurrencyUnit set.
     *
     * @param conditionCurrencyUnit the conditionCurrencyUnit to set
     */
    public void setConditionCurrencyUnit(String conditionCurrencyUnit) {
        this.conditionCurrencyUnit = conditionCurrencyUnit;
    }

    /**
     * Get condition period value -- A placeholder to record the period value.
     *
     * @return the conditionPeriodValue
     */
    public Long getConditionPeriodValue() {
        return conditionPeriodValue;
    }

    /**
     * Set condition period value -- A placeholder to record the period value.
     *
     * @param conditionPeriodValue the conditionPeriodValue to set
     */
    public void setConditionPeriodValue(Long conditionPeriodValue) {
        this.conditionPeriodValue = conditionPeriodValue;
    }

    /**
     * Get condition distance value -- A placeholder to record the distance value.
     *
     * @return the conditionDistanceValue
     */
    public Long getConditionDistanceValue() {
        return conditionDistanceValue;
    }

    /**
     * Set condition distance value -- A placeholder to record the distance value.
     *
     * @param conditionDistanceValue the conditionDistanceValue to set
     */
    public void setConditionDistanceValue(Long conditionDistanceValue) {
        this.conditionDistanceValue = conditionDistanceValue;
    }

    /**
     * Get condition currency amount -- A placeholder to record the currency value
     *
     * @return the conditionCurrencyAmount
     */
    public BigDecimal getConditionCurrencyAmount() {
        return conditionCurrencyAmount;
    }

    /**
     * Set condition currency amount -- A placeholder to record the currency value
     *
     * @param conditionCurrencyAmount the conditionCurrencyAmount to set
     */
    public void setConditionCurrencyAmount(BigDecimal conditionCurrencyAmount) {
        this.conditionCurrencyAmount = conditionCurrencyAmount;
    }

    /**
     * Get condition details -- The field is used to store standard legal description for the conditions.
     *
     * @return the conditionDetails
     */
    public String getConditionDetails() {
        return conditionDetails;
    }

    /**
     * Set condition details -- The field is used to store standard legal description for the conditions.
     *
     * @param conditionDetails the conditionDetails to set
     */
    public void setConditionDetails(String conditionDetails) {
        this.conditionDetails = conditionDetails;
    }

    /**
     * Get condition satisfied status -- A placeholder to capture the fact that a condition has been satisfied for say release purposes.
     *
     * @return the isConditionSatisfied
     */
    public Boolean getIsConditionSatisfied() {
        return isConditionSatisfied;
    }

    /**
     * Set condition satisfied status -- A placeholder to capture the fact that a condition has been satisfied for say release purposes.
     *
     * @param isConditionSatisfied the isConditionSatisfied to set
     */
    public void setIsConditionSatisfied(Boolean isConditionSatisfied) {
        this.isConditionSatisfied = isConditionSatisfied;
    }

    /**
     * Get condition amendment date -- A placeholder to capture the date
     * an amendment was made to the conditions imposed by a court e.g. court reduces the period of community service.
     * All details of the amendment will be available with the Order it arose from.
     * The presence of the amended date indicates that the condition was amended.
     *
     * @return the conditionAmendmentDate
     */
    public Date getConditionAmendmentDate() {
        return conditionAmendmentDate;
    }

    /**
     * Set condition amendment date -- A placeholder to capture the date
     * an amendment was made to the conditions imposed by a court e.g. court reduces the period of community service.
     * All details of the amendment will be available with the Order it arose from.
     * The presence of the amended date indicates that the condition was amended.
     *
     * @param conditionAmendmentDate the conditionAmendmentDate to set
     */
    public void setConditionAmendmentDate(Date conditionAmendmentDate) {
        this.conditionAmendmentDate = conditionAmendmentDate;
    }

    /**
     * Get condition amendment status -- A placeholder to capture the status of the Amendment
     * which could be- Accepted, Rejected, In Progress.
     * It is a reference code value of ConditionAmendmentStatus set.
     *
     * @return the conditionAmendmentStatus
     */
    public String getConditionAmendmentStatus() {
        return conditionAmendmentStatus;
    }

    /**
     * Set condition amendment status -- A placeholder to capture the status of the Amendment
     * which could be- Accepted, Rejected, In Progress.
     * It is a reference code value of ConditionAmendmentStatus set.
     *
     * @param conditionAmendmentStatus the conditionAmendmentStatus to set
     */
    public void setConditionAmendmentStatus(String conditionAmendmentStatus) {
        this.conditionAmendmentStatus = conditionAmendmentStatus;
    }

    /**
     * Get a set of charge IDs
     *
     * @return the chargeIds
     */
    public Set<Long> getChargeIds() {
        if (chargeIds == null) {
			chargeIds = new HashSet<Long>();
		}
        return chargeIds;
    }

    /**
     * Set a set of Charge IDs
     *
     * @param chargeIds the chargeIds to set
     */
    public void setChargeIds(Set<Long> chargeIds) {
        this.chargeIds = chargeIds;
    }

    /**
     * Get an OrderSentence Id
     *
     * @return the orderSentenceId
     */
    public Long getOrderSentenceId() {
        return orderSentenceId;
    }

    /**
     * Set an OrderSentence Id
     *
     * @param orderSentenceId the orderSentenceId to set
     */
    public void setOrderSentenceId(Long orderSentenceId) {
        this.orderSentenceId = orderSentenceId;
    }

    /**
     * Get a set of Case Information IDs
     *
     * @return the caseInfoIds
     */
    public Set<Long> getCaseInfoIds() {
        if (caseInfoIds == null) {
			caseInfoIds = new HashSet<Long>();
		}
        return caseInfoIds;
    }

    /**
     * Set a set of Case Information IDs
     *
     * @param caseInfoIds the caseInfoIds to set
     */
    public void setCaseInfoIds(Set<Long> caseInfoIds) {
        this.caseInfoIds = caseInfoIds;
    }

    public boolean isHistorical() {
        return isHistorical;
    }

    public void setHistorical(boolean isHistorical) {
        this.isHistorical = isHistorical;
    }

    /**
     * @return the clientCustomFieldValueTypeList
     */
    public List<ClientCustomFieldValueType> getClientCustomFieldValueTypeList() {
        return clientCustomFieldValueTypeList;
    }

    /**
     * @param clientCustomFieldValueTypeList the clientCustomFieldValueTypeList to set
     */
    public void setClientCustomFieldValueTypeList(List<ClientCustomFieldValueType> clientCustomFieldValueTypeList) {
        this.clientCustomFieldValueTypeList = clientCustomFieldValueTypeList;
    }

    /* (non-Javadoc)
     * @see java.lang.Object#hashCode()
     */
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((caseInfoIds == null) ? 0 : caseInfoIds.hashCode());
        result = prime * result + ((chargeIds == null) ? 0 : chargeIds.hashCode());
        result = prime * result + ((conditionAmendmentDate == null) ? 0 : conditionAmendmentDate.hashCode());
        result = prime * result + ((conditionAmendmentStatus == null) ? 0 : conditionAmendmentStatus.hashCode());
        result = prime * result + ((conditionCategory == null) ? 0 : conditionCategory.hashCode());
        result = prime * result + ((conditionComments == null) ? 0 : conditionComments.hashCode());
        result = prime * result + ((conditionCreateDate == null) ? 0 : conditionCreateDate.hashCode());
        result = prime * result + ((conditionCurrencyAmount == null) ? 0 : conditionCurrencyAmount.hashCode());
        result = prime * result + ((conditionCurrencyUnit == null) ? 0 : conditionCurrencyUnit.hashCode());
        result = prime * result + ((conditionDetails == null) ? 0 : conditionDetails.hashCode());
        result = prime * result + ((conditionDistanceUnit == null) ? 0 : conditionDistanceUnit.hashCode());
        result = prime * result + ((conditionDistanceValue == null) ? 0 : conditionDistanceValue.hashCode());
        result = prime * result + ((conditionEndDate == null) ? 0 : conditionEndDate.hashCode());
        result = prime * result + ((conditionId == null) ? 0 : conditionId.hashCode());
        result = prime * result + ((conditionPeriodUnit == null) ? 0 : conditionPeriodUnit.hashCode());
        result = prime * result + ((conditionPeriodValue == null) ? 0 : conditionPeriodValue.hashCode());
        result = prime * result + ((conditionStartDate == null) ? 0 : conditionStartDate.hashCode());
        result = prime * result + ((conditionSubCategory == null) ? 0 : conditionSubCategory.hashCode());
        result = prime * result + ((conditionType == null) ? 0 : conditionType.hashCode());
        result = prime * result + ((isConditionSatisfied == null) ? 0 : isConditionSatisfied.hashCode());
        result = prime * result + ((isConditionStatus == null) ? 0 : isConditionStatus.hashCode());
        result = prime * result + (isHistorical ? 1231 : 1237);
        result = prime * result + ((orderSentenceId == null) ? 0 : orderSentenceId.hashCode());
        result = prime * result + ((shortName == null) ? 0 : shortName.hashCode());
        return result;
    }

    /* (non-Javadoc)
     * @see java.lang.Object#equals(java.lang.Object)
     */
    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
			return true;
		}
        if (obj == null) {
			return false;
		}
        if (getClass() != obj.getClass()) {
			return false;
		}
        ConditionType other = (ConditionType) obj;
        if (caseInfoIds == null) {
            if (other.caseInfoIds != null) {
				return false;
			}
        } else if (!caseInfoIds.equals(other.caseInfoIds)) {
			return false;
		}
        if (chargeIds == null) {
            if (other.chargeIds != null) {
				return false;
			}
        } else if (!chargeIds.equals(other.chargeIds)) {
			return false;
		}
        if (conditionAmendmentDate == null) {
            if (other.conditionAmendmentDate != null) {
				return false;
			}
        } else if (!conditionAmendmentDate.equals(other.conditionAmendmentDate)) {
			return false;
		}
        if (conditionAmendmentStatus == null) {
            if (other.conditionAmendmentStatus != null) {
				return false;
			}
        } else if (!conditionAmendmentStatus.equals(other.conditionAmendmentStatus)) {
			return false;
		}
        if (conditionCategory == null) {
            if (other.conditionCategory != null) {
				return false;
			}
        } else if (!conditionCategory.equals(other.conditionCategory)) {
			return false;
		}
        if (conditionComments == null) {
            if (other.conditionComments != null) {
				return false;
			}
        } else if (!conditionComments.equals(other.conditionComments)) {
			return false;
		}
        if (conditionCreateDate == null) {
            if (other.conditionCreateDate != null) {
				return false;
			}
        } else if (!conditionCreateDate.equals(other.conditionCreateDate)) {
			return false;
		}
        if (conditionCurrencyAmount == null) {
            if (other.conditionCurrencyAmount != null) {
				return false;
			}
        } else if (!conditionCurrencyAmount.equals(other.conditionCurrencyAmount)) {
			return false;
		}
        if (conditionCurrencyUnit == null) {
            if (other.conditionCurrencyUnit != null) {
				return false;
			}
        } else if (!conditionCurrencyUnit.equals(other.conditionCurrencyUnit)) {
			return false;
		}
        if (conditionDetails == null) {
            if (other.conditionDetails != null) {
				return false;
			}
        } else if (!conditionDetails.equals(other.conditionDetails)) {
			return false;
		}
        if (conditionDistanceUnit == null) {
            if (other.conditionDistanceUnit != null) {
				return false;
			}
        } else if (!conditionDistanceUnit.equals(other.conditionDistanceUnit)) {
			return false;
		}
        if (conditionDistanceValue == null) {
            if (other.conditionDistanceValue != null) {
				return false;
			}
        } else if (!conditionDistanceValue.equals(other.conditionDistanceValue)) {
			return false;
		}
        if (conditionEndDate == null) {
            if (other.conditionEndDate != null) {
				return false;
			}
        } else if (!conditionEndDate.equals(other.conditionEndDate)) {
			return false;
		}
        if (conditionId == null) {
            if (other.conditionId != null) {
				return false;
			}
        } else if (!conditionId.equals(other.conditionId)) {
			return false;
		}
        if (conditionPeriodUnit == null) {
            if (other.conditionPeriodUnit != null) {
				return false;
			}
        } else if (!conditionPeriodUnit.equals(other.conditionPeriodUnit)) {
			return false;
		}
        if (conditionPeriodValue == null) {
            if (other.conditionPeriodValue != null) {
				return false;
			}
        } else if (!conditionPeriodValue.equals(other.conditionPeriodValue)) {
			return false;
		}
        if (conditionStartDate == null) {
            if (other.conditionStartDate != null) {
				return false;
			}
        } else if (!conditionStartDate.equals(other.conditionStartDate)) {
			return false;
		}
        if (conditionSubCategory == null) {
            if (other.conditionSubCategory != null) {
				return false;
			}
        } else if (!conditionSubCategory.equals(other.conditionSubCategory)) {
			return false;
		}
        if (conditionType == null) {
            if (other.conditionType != null) {
				return false;
			}
        } else if (!conditionType.equals(other.conditionType)) {
			return false;
		}
        if (isConditionSatisfied == null) {
            if (other.isConditionSatisfied != null) {
				return false;
			}
        } else if (!isConditionSatisfied.equals(other.isConditionSatisfied)) {
			return false;
		}
        if (isConditionStatus == null) {
            if (other.isConditionStatus != null) {
				return false;
			}
        } else if (!isConditionStatus.equals(other.isConditionStatus)) {
			return false;
		}
        if (isHistorical != other.isHistorical) {
			return false;
		}
        if (orderSentenceId == null) {
            if (other.orderSentenceId != null) {
				return false;
			}
        } else if (!orderSentenceId.equals(other.orderSentenceId)) {
			return false;
		}
        if (shortName == null) {
            if (other.shortName != null) {
				return false;
			}
        } else if (!shortName.equals(other.shortName)) {
			return false;
		}
        return true;
    }

    /* (non-Javadoc)
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString() {
        return "ConditionType [conditionId=" + conditionId + ", conditionCreateDate=" + conditionCreateDate + ", conditionStartDate=" + conditionStartDate
                + ", conditionEndDate=" + conditionEndDate + ", conditionComments=" + conditionComments + ", isConditionStatus=" + isConditionStatus + ", conditionType="
                + conditionType + ", conditionCategory=" + conditionCategory + ", conditionSubCategory=" + conditionSubCategory + ", conditionPeriodUnit="
                + conditionPeriodUnit + ", conditionDistanceUnit=" + conditionDistanceUnit + ", conditionCurrencyUnit=" + conditionCurrencyUnit
                + ", conditionPeriodValue=" + conditionPeriodValue + ", conditionDistanceValue=" + conditionDistanceValue + ", conditionCurrencyAmount="
                + conditionCurrencyAmount + ", conditionDetails=" + conditionDetails + ", isConditionSatisfied=" + isConditionSatisfied + ", conditionAmendmentDate="
                + conditionAmendmentDate + ", conditionAmendmentStatus=" + conditionAmendmentStatus + ", orderSentenceId=" + orderSentenceId + ", chargeIds=" + chargeIds
                + ", caseInfoIds=" + caseInfoIds + ", casePlanId=" + casePlanId + ", isHistorical=" + isHistorical + ", shortName=" + shortName + "]";
    }

    /**
     * Gets the Short Name of the Condition.
     *
     * @return String - the shortName
     */
    public String getShortName() {
        return shortName;
    }

    /**
     * Sets the Short Name of the Condition.
     *
     * @param String - the shortName
     */
    public void setShortName(String shortName) {
        this.shortName = shortName;
    }

    /**
     * Throw IllegalArgumentException when required property is null or not well formed.
     *
     * @param propertyName
     */
    private void unwellFormed(String propertyName) {
        throw new IllegalArgumentException("Null or not well formed " + propertyName);
    }

    /**
     * Throw IllegalArgumentException when required property is invalid.
     *
     * @param propertyName
     */
    private void invalid(String propertyName) {
        throw new IllegalArgumentException("Invalid " + propertyName);
    }

    /**
     * Get associated Case Plan Id;
     *
     * @return the casePlanId - Long
     */
    public Long getCasePlanId() {
        return casePlanId;
    }

    /**
     * Set associated Case Plan Id;
     *
     * @param Long the casePlanId to set
     */
    public void setCasePlanId(Long casePlanId) {
        this.casePlanId = casePlanId;
    }

}
